;
(function () {

	window._w.auction = {

		ti: null,
		rawData: {},
		gridData: {},
		dfrom: '',
		dto: '',
		basketOnly: false,
		gridStatus: null,
		refresher: false,


		onPageDestruct: function ()
		{
			App.Event.removeListener('auctionGridSuFilter', 'SuChange');
			//_.Api.websocket.close();
			//_w.websocketRunning = false;
			if (false !== _w.auction.refresher)
			{
				clearInterval(_w.auction.refresher);
				_w.auction.refresher = false;
			}
		},

		onPushConnect: function()
		{
			console.log('onPushConnect');
			/*if (false !== _w.auction.refresher)
			{
				clearInterval(_w.auction.refresher);
				_w.auction.refresher = false;
			}*/
		},

		onPushDisconnect: function()
		{
			if (!_w.websocketRunning)
			{
				return;
			}
			console.log('onPushDisconnect');
			/*if (false === _w.auction.refresher)
			{
				_w.auction.refresher = setInterval(
					function ()
					{
						console.log('refreshing auction grid');
						_w.auction.loadAuctionGrid(null, {}, {});
					},
					120000
				);
			}*/
		},

		onPushMessage: function (data)
		{
			if (_w.auction.gridData && _w.auction.gridData['i' + data.id])
			{
				var aid = 'a' + data.id;
				if (0 < _w.auction.rawData.DataSet[aid].numAllBids)
				{
					_w.auction.rawData.DataSet[aid].currentBidCompanyId = data.current_bid.company;
				}
				_w.auction.rawData.DataSet[aid].currentBidPrice = data.current_bid.amount;
				_w.auction.rawData.DataSet[aid].numBids = data.number_of_bids;
				_w.auction.rawData.DataSet[aid].numAllBids = parseInt(_w.auction.rawData.DataSet[aid].numAllBids) + 1;
				_w.auction.rawData.DataSet[aid].numendDateBids = data.expire_datetime;
				if (data.basket.company == App.companyData.id)
				{
					_w.auction.rawData.DataSet[aid].baskets = [[{
						id: data.basket.id,
						archived: data.basket.archived
					}]];
				}
				_w.auction._buildGrid();
			}
			if (_w.bidview && _w.bidview.ti && _w.bidview.ti.published && _w.bidview.itemId == data.id)
			{
				console.log();
				App.API.getTask(
					'viewAuction:' + _w.bidview.itemId, 'Auction', 'Auction.View', _w.bidview.itemId,
					{}, $.proxy(_w.bidview._onStockViewDataReceived, _w.bidview), _w.taskContractError
				);
			}
			if (data.winner != App.companyData.id && data.looser == App.companyData.id)
			{
				if (!_w.bidview || !_w.bidview.ti || !_w.bidview.ti.published || _w.bidview.itemId != data.id)
				{
					alert('You were just outbid on the following vehicle: ' + data.vehicle);
				}
			}
		},

		onAuctionPageTemplateReady: function (template, event, eventData)
		{
			_w.auction.ti = _t[template];
			if (!_w.websocketRunning || undefined == _w.websocketRunning)
			{
				_w.websocketRunning = true;
				_.Api.websocket._initialize();
				_.Api.websocket._messageCallback = _w.auction.onPushMessage;
				_.Api.websocket._connectionOpenedCallback = _w.auction.onPushConnect;
				_.Api.websocket._connectionClosedCallback = _w.auction.onPushDisconnect;

                console.log('_w.websocketRunning',_w.websocketRunning);

			}
			App.DataStore.setData('auctionstatuses',
				[
					{"value": "Active", "label": "Active"},
					{"value": "Sold", "label": "Purchased"}
				]
			);
			App.DataStore.loadSelectListData('filtermakes', true, 'Stock', 'Make.SelectList');
			App.DataStore.loadSelectListData('makesmobi', true, 'Stock', 'Make.SelectList');
			App.DataStore.loadSelectListData('regionsmobi', true, 'Location', 'Region.SelectList');
			App.DataStore.loadSelectListData('regions', true, 'Location', 'Region.SelectList');
			_w.auction.ti.hydrate({
				'gridTitle': 'Auction',
				'gridTitleSubtext': 'Please use the filters below to narrow down the view',
				'gridTitleButtons': {
					constructor: 'Button',
					items: {
						Export: {
							preset: 'GridExport',
							id: 'exportAuctionGrid',
							handler: _w.auction.exportAuctionGrid,
							permission: App.permissions.stockGridExport
						},
						New: {
							preset: 'SellVehicle',
							id: 'SellVehicle ',
							style: 'MakeMobi hidden-tablet hidden-phone',
							handler: _w.stock.SellVehicle,
							permission: App.permissions.stockRouteAuction
							            && App.permissions.stockPage
							            && App.permissions.stockCreateAuction
						}

					}

				},
				// hide all the elements exept for the ones to use on mobi / create duplicate ones for mobi
				'gridContextFilter': {
					constructor: 'GridContextFilter',
					items: {

						//RefNum: {
						//	title: 'Search here:',
						//	style: 'filter-input-wrapper hidden-tablet hidden-phone',
						//	id: 'gridAuctionContext_RefNo',
						//	placeholder: 'Ref number',
						//	context: 'gridAuctionContext'
						//},
						//RegNum: {
						//	style: 'filter-input-wrapper hidden-tablet hidden-phone',
						//	id: 'gridAuctionContext_RegNo',
						//	placeholder: 'Registration number',
						//	context: 'gridAuctionContext'
						//},
						//DateFrom: {
						//	style: 'input-append date filter-input-wrapper-date mobile-width12p dfrom hidden-tablet hidden-phone',
						//	title: 'Search by date here',
						//	id: 'gridAuctionContext_DateFrom',
						//	placeholder: 'From',
						//	context: 'gridAuctionContext',
						//	append: '<i class="icon-calendar"></i>',
						//	readonly: true,
						//	bind: function () {
						//		$('#gridAuctionContext_DateFrom').change(function () {
						//			_w.auction.dFrom = $(this).val();
						//		});
						//	}
						//},
						//DateTo: {
						//	style: 'input-append date filter-input-wrapper-date mobile-width12p dto hidden-tablet hidden-phone',
						//	id: 'gridAuctionContext_DateTo',
						//	placeholder: 'To',
						//	context: 'gridAuctionContext',
						//	append: '<i class="icon-calendar"></i>',
						//	readonly: true,
						//	bind: function () {
						//		$('#gridAuctionContext_DateTo').change(function () {
						//			_w.auction.dTo = $(this).val();
						//		});
						//	}
						//},
						MakeMobi: {
							style: 'filter-input-wrapper filter-input-select',
							placeholder: 'Make Mobi',
							id: 'gridAuctionFilter_MakeMobi',
							context: 'gridAuctionContext',
							dataStoreId: 'filtermakes',
							selectEmpty: 'All Makes',
							style: 'MakeMobi hidden-desktop hidden-tablet visible-phone',
							bind: function (meta) {
								$('#gridAuctionFilter_MakeMobi').change(function () {
									$('#gridAuctionFilter_Make').selectpicker('val', $(this).val());
								});
							}
						},
						RegionMobi: {
							style: 'filter-input-wrapper filter-input-select ',
							placeholder: 'Region Mobi',
							id: 'gridAuctionFilter_RegionMobi',
							context: 'gridAuctionContext',
							dataStoreId: 'regionsmobi',
							selectEmpty: 'Regions',
							style: 'RegionMobi hidden-desktop hidden-tablet visible-phone',
							bind: function (meta) {
								$('#gridAuctionFilter_RegionMobi').change(function () {
									$('#gridAuctionFilter_Region').selectpicker('val', $(this).val());
								});
							}
						},
						RegNumMobi: {
							style: 'filter-input-wrapper hidden-desktop',
							id: 'gridAuctionContext_RegNoMobi',
							placeholder: 'Registration number',
							context: 'gridAuctionContext'
						},
						Buttons: {
							//actions: true,
							//searchId: 'btnSearch',
							//bindSearch: _w.auction.searchAuctionGrid,
							//clearId: 'btnClearSearch',
							//bindClear: _w.auction.clearAuctionGridContext

						}
					}
				},
				'gridColumnHeaders': {
					constructor: 'GridColumnHeader',
					items: {
						//Seller: {
						//	id: 'gridAuctionColumn_Seller',
						//	title: 'SELLER',
						//	orderAsc: {
						//		id: 'gridAuctionOrder_SellerAsc',
						//		bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.auctionCompanyName', 'ASC')
						//	},
						//	orderDesc: {
						//		id: 'gridAuctionOrder_SellerDesc',
						//		bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.auctionCompanyName', 'DESC')
						//	},
						//	style: 'hidden-phone'
						//},
						Make: {
							id: 'gridAuctionColumn_Make',
							title: 'MAKE',
							orderAsc: {
								id: 'gridAuctionOrder_MakeAsc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.makeId', 'ASC')
							},
							orderDesc: {
								id: 'gridAuctionOrder_MakeDesc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.makeId', 'DESC')
							},
							style: 'hidden-phone'
						},
						Model: {
							id: 'gridAuctionColumn_Model',
							title: 'MODEL',
							orderAsc: {
								id: 'gridAuctionOrder_ModelAsc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.modelName', 'ASC')
							},
							orderDesc: {
								id: 'gridAuctionOrder_ModelDesc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.modelName', 'DESC')
							},
							style: 'hidden-phone'
						},
						Type: {
							id: 'gridAuctionColumn_Type',
							title: 'TYPE',
							orderAsc: {
								id: 'gridAuctionOrder_TypeAsc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.typeName', 'ASC')
							},
							orderDesc: {
								id: 'gridAuctionOrder_TypeDesc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.typeName', 'DESC')
							}

						},
						Year: {
							id: 'gridAuctionColumn_Year',
							title: 'YEAR',
							orderAsc: {
								id: 'gridAuctionOrder_YearAsc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.yearName', 'ASC')
							},
							orderDesc: {
								id: 'gridAuctionOrder_YearDesc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.yearName', 'DESC')
							},
							style: 'year'
						},
						KM: {
							id: 'gridAuctionColumn_KM',
							title: 'KM&#39;S',
							orderAsc: {
								id: 'gridAuctionOrder_KMAsc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.stockKm', 'ASC')
							},
							orderDesc: {
								id: 'gridAuctionOrder_KMDesc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.stockKm', 'DESC')
							},
							style: 'kms hidden-phone'
						},
						Region: {
							id: 'gridAuctionColumn_Retail',
							title: 'TOWN',
							orderAsc: {
								id: 'gridAuctionOrder_RegionAsc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.regionName', 'ASC')
							},
							orderDesc: {
								id: 'gridAuctionOrder_RegionDesc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.regionName', 'DESC')
							},
							style: 'hidden-phone'
						},
						Bid: {
							id: 'gridAuctionColumn_Bid',
							title: 'AMOUNT',
							orderAsc: {
								id: 'gridAuctionOrder_BidAsc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.currentBidPrice', 'ASC')
							},
							orderDesc: {
								id: 'gridAuctionOrder_BidDesc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.currentBidPrice', 'DESC')
							},
							style: 'amount'
						},
						Bids: {
							id: 'gridAuctionColumn_Bids',
							title: 'BIDS',
							orderAsc: {
								id: 'gridAuctionOrder_BidsAsc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.numberOfBids', 'ASC')
							},
							orderDesc: {
								id: 'gridAuctionOrder_BidsDesc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.numberOfBids', 'DESC')
							},
							style: 'bids hidden-phone'
						},
						Time: {
							id: 'gridAuctionColumn_Time',
							title: 'TIME LEFT',
							orderAsc: {
								id: 'gridAuctionOrder_TimeAsc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.endDate', 'ASC')
							},
							orderDesc: {
								id: 'gridAuctionOrder_TimeDesc',
								bind: $.proxy(_w.auction.orderAuctionGrid, this, 'auction.endDate', 'DESC')
							},
							style: 'time '

						},
						BidView: {
							id: 'gridAuctionColumn_BidView',
							title: 'BID/VIEW',
							style: 'hidden-phone'
						},
						Basket: {
							id: 'gridAuctionColumn_Basket',
							title: 'MY BASKET',
							style: 'hidden-phone'
						},
					}
				},

				'gridColumnFilters': {
					constructor: 'GridColumnFilter',
					items: {
						//Seller: {
						//	id: 'gridAuctionFilter_Seller',
						//	context: 'gridAuctionFilter'
						//},
						Make: {
							id: 'gridAuctionFilter_Make',
							context: 'gridAuctionFilter',
							dataStoreId: 'filtermakes',
							selectEmpty: 'All',
							bind: function (meta) {
								_w.auction.changes = 0;
								$('#' + meta.id).change(function () {
									_w.auction.changes++;
									if (1 == _w.auction.changes || 'Active' != _w.auction.gridStatus)
									{
										return;
									}
									_w.auction.searchAuctionGrid();
								});
							}
						},
						Model: {
							id: 'gridAuctionFilter_Model',
							context: 'gridAuctionFilter'
						},
						Type: {
							id: 'gridAuctionFilter_Type',
							context: 'gridAuctionFilter'
						},
						Year: {
							id: 'gridAuctionFilter_Year',
							context: 'gridAuctionFilter'
						},
						KM: {
							id: 'gridAuctionFilter_KM',
							context: 'gridAuctionFilter'
						},
						Region: {
							id: 'gridAuctionFilter_Region',
							context: 'gridAuctionFilter',
							dataStoreId: 'regions',
							selectEmpty: 'All',
							bind: function (meta) {
								_w.auction.changes = 0;
								$('#' + meta.id).change(function () {
									_w.auction.changes++;
									if (1 == _w.auction.changes || 'Active' != _w.auction.gridStatus)
									{
										return;
									}
									_w.auction.searchAuctionGrid();
								});
							}
						},

						Bid: {
							id: 'gridAuctionFilter_Bid',
							context: 'gridAuctionFilter'
						},
						Bids: {
							id: 'gridAuctionFilter_Bids',
							context: 'gridAuctionFilter'
						},
						Time: {id: false},
						BidView: {},
						Basket: {},
					}
				},
				'gridRowRepeater': {},
				'gridPager': {}
			});

			// Retrieve initial grid data.
			if (null == App.API.taskContract('gridAuction'))
			{
				App.API.getTask(
					'gridAuction', 'Auction', 'Auction.Grid', null,
					{}, function () {
						request = {
							"Grid": {
								"Page": 1,
								"Filter": {
									'auction.jobState': 'Active'
								}
							}
						};
						_w.auction.loadAuctionGrid(null, request, {});
					}, _w.taskContractError
				);
			}
			else
			{
				_w.auction.loadAuctionGrid(null, {}, {});
			}
		},

		onAuctionGridPublished: function ()
		{

			//mobi menu
			var isMobile = 'none' == $('#mobiCheck').css('display');
			if (isMobile)
			{
				// show the mobi menu && hide old menu 
				$("#MobiAuctionPriceGuideMenu").show();
				$("#MobiPortalMenu").hide();

				// Check active state
				$("#mobiAuctionBtn").addClass("active");
				$("#mobiPriceGuideBtn").removeClass("active");
				$("#mobiValuationsBtn").removeClass("active");
			}

			$("#mobiPriceGuideBtn").click(function () {
				window.location.hash = '#/priceguide';
			});

			$("#mobiValuationsBtn").click(function () {
				window.location.hash = '#/valuations';
			});


			$(".gridAuctionFilter").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode == 13)
				{ //Enter key's keycode
					$('#btnSearch').click();
				}

			});
			$(".gridAuctionContext").keyup(function (evt) {
				var charCode = evt.charCode || evt.keyCode;
				if (charCode == 13)
				{ //Enter key's keycode
					$('#btnSearch').click();
				}

			});

			$('#btnBasket, #btnBasketMobi').click(function () {
				if (_w.auction.basketOnly)
				{
					_w.auction.basketOnly = false;
					$('#btnBasket').html('<i class="icon-shopping-cart icon-white"></i> My basket');
				}
				else
				{
					_w.auction.basketOnly = true;
					$('#btnBasket').html('Show All');
				}
				$('#gridAuctionFilter_basket').val(_w.auction.basketOnly ? '1' : '');
				_w.auction.searchAuctionGrid();
			});

			var setTableFormWidth = function ()
			{
				$('.table-form').css({
					width: $(window).width() * 0.98
				});
			};

			$(window).on('resize', setTableFormWidth);
			setTableFormWidth();
			App.Event.listen('auctionGridSuFilter', 'SuChange', $.proxy(_w.auction.loadAuctionGrid, this), 'Recurring');
			$('#exportAuctionGrid').prop('disabled', !App.permissions.auctionGridExport);
			$('.dfrom').datepicker({format: "yyyy-mm-dd"});
			$('.dto').datepicker({format: "yyyy-mm-dd"});
			$('#gridAuctionContext_DateFrom').val(_w.auction.dFrom);
			$('#gridAuctionContext_DateTo').val(_w.auction.dTo);
			if ('open' != _.Api.websocket._state)
			{
				_w.auction.onPushDisconnect();
			}
		},

		pageAuctionGrid: function (page)
		{
			_w.auction.loadAuctionGrid({}, {"Grid": {"Page": page}});
		},

		loadAuctionGrid: function (contract, data, options)
		{
			App.API.execTask(
				'gridAuction', data, options,
				_w.auction._onAuctionGridDataReceived, _w.taskExecError
			);
		},

		_buildGrid: function ()
		{
			_w.auction.gridData = {};
			for (var i in _w.auction.rawData.DataSet)
			{
				var row = _w.auction.rawData.DataSet[i];

				var checkBox = '';
				if (row.auctionCompanyId != App.companyData.id && row.stockCompanyId != App.companyData.id)
				{
					var checked = row.baskets[0] && row.baskets[0][0] && false == row.baskets[0][0]['archived']
						? ' checked'
						: '';
					checkBox += '<input type="checkbox" id="' + row.id + 'Check" ';
					checkBox += 'value="" class="checkbox checkbox-line" ' + checked + '>';
				}
				if (row.auctionCompanyId == App.companyData.id
				    || (0 < row.numAllBids && row.currentBidCompanyId == App.companyData.id)
				    || (row.stockCompanyId == App.companyData.id))
				{
					buttonVal = 'View';
					buttonClass = row.auctionCompanyId == App.companyData.id || row.stockCompanyId == App.companyData.id
						? ''
						: 'btn-primary';
				}
				else
				{
					buttonVal = 'Bid/View';
					buttonClass = 0 < row.numBids
						? 'btn-success'
						: '';
				}

				var basketId = row.baskets[0] && row.baskets[0][0] && row.baskets[0][0].id
					? row.baskets[0][0].id
					: false;

				_w.auction.gridData['i' + row.id] = {
					surl: 'bidview',
					prepend: {
						Trade: 'R ',
						Retail: 'R ',
						Bid: 'R '
					},
					rowId: row.id,
					basketId: basketId,
					bind: function (meta) {
						App.Util.updateCheckboxStyle($('#' + meta.rowId + 'Check'));
						$('#row' + meta.rowId).click(function (e) {
							setTimeout(function () {
								if (!_w.checkBoxChanged)
								{
									window.location = '#/' + meta.surl + '?id=' + meta.rowId + '&basketId=' + meta.basketId;
								}
								_w.checkBoxChanged = false;
							}, 100);
						});
						$('#' + meta.rowId + 'Check').prop('data-auction-id', meta.rowId);
						$('#' + meta.rowId + 'Check').prop('data-basket-id', meta.basketId);
						$('#' + meta.rowId + 'Check').click(function (e) {
							_w.checkBoxChanged = true;
							e.preventDefault();
							e.stopPropagation();
							var archived = $('#' + meta.rowId + 'Check').prop('checked')
								? false
								: true;
							var aucId = $('#' + meta.rowId + 'Check').prop('data-auction-id');
							var basId = $('#' + meta.rowId + 'Check').prop('data-basket-id');
							if (!basId)
							{
								App.API.getTask(
									'createBasket:' + aucId, 'Auction', 'Basket.Create',
									aucId, {}, function () {
										App.API.execTask(
											'createBasket:' + aucId, {Basket: {auction: aucId}}, {},
											function () {
												_w.auction.loadAuctionGrid(null, {}, {});
											}, _w.taskExecError
										);
									}, _w.taskContractError
								);
							}
							else
							{
								App.API.getTask(
									'updateBasket:' + aucId, 'Auction', 'Basket.SetStatus',
									aucId, {id: basId}, function () {
										App.API.execTask(
											'updateBasket:' + aucId, {Basket: {archived: archived}}, {},
											function () {
												_w.auction.loadAuctionGrid(null, {}, {});
											}, _w.taskExecError
										);
									}, _w.taskContractError
								);
							}
						});
					},
					style: {
						Seller: 'hidden',
						Make: 'make hidden-phone',
						Model: 'hidden-phone',
						Type: 'type',
						Year: 'year',
						KM: 'hidden-phone',
						Region: 'hidden-phone',
						Bid: 'amount',
						Bids: 'hidden-phone',
						Time: 'Time',
						BidView: 'hidden-phone',
						Basket: 'hidden-phone'

					},
					lineClass: buttonClass == 'btn-primary' && buttonVal == 'View'
						? 'line-primary'
						: '',
					items: {
						'id': {id: row.id, basketId: basketId},
						'Seller': row.auctionCompanyName,
						'Make': row.makeName,
						'Model': row.modelName,
						'Type': row.typeName,
						'Year': row.yearName,
						'KM': row.stockKm,
						'Region': row.regionName,
						'Bid': row.currentBidPrice,
						'Bids': row.numAllBids,
						'Time': App.Util.calculateTimeLeft(row.created, null, row.endDate),
						'BidView': '<button class="btn ' + buttonClass + '">' + buttonVal + '</button>',
						'Basket': checkBox
					}
				};
			}
			_w.checkBoxChanged = false;
			_w.auction.ti.hydrateParam('gridRowRepeater', {
				constructor: 'GridDataRow',
				items: _w.auction.gridData
			});
		},

		_onAuctionGridDataReceived: function (response)
		{
			_w.auction.gridStatus = 'Active';
			_w.auction.ti.hydrateParam('gridRowRepeater', {});
			_w.auction.basketOnly = undefined != response.Data.Meta.Filters['basket.archived'];
			_w.populateFilters(response.Data.Meta.Filters, {
				'auction.referenceNumber': 'gridAuctionContext_RefNo',
				'basket.archived': 'gridAuctionFilter_basket',
				'auction.auctionCompanyName': 'gridAuctionFilter_Seller',
				'auction.modelName': 'gridAuctionFilter_Model',
				'auction.typeName': 'gridAuctionFilter_Type',
				'auction.yearName': 'gridAuctionFilter_Year',
				'auction.stockKm': 'gridAuctionFilter_KM',
				'auction.regionId': 'gridAuctionFilter_Region',
				'auction.makeId': 'gridAuctionFilter_Make',
				'auction.currentBidPrice': 'gridAuctionFilter_Bid',
				'numBids': 'gridAuctionFilter_Bids'
			});
			$('select.gridAuctionFilter').each(function (i, elem) {
				$(elem).selectpicker('refresh');
			});
			if (response.Data.Meta.Filters['basket.archived'])
			{
				_w.auction.basketOnly = true;
				$('#btnBasket').html('Show All');
			}
			else
			{
				;
				_w.auction.basketOnly = false;
				$('#btnBasket').html('<i class="icon-shopping-cart icon-white"></i> My basket');
			}
			$('select.gridAuctionFilter').each(function (i, elem) {
				$(elem).selectpicker('refresh');
			});
			_w.auction.rawData = {
				DataSet: {},
				Meta: response.Data.Meta
			};
			for (var i = 0; i < response.Data.DataSet.length; i++)
			{
				_w.auction.rawData.DataSet['a' + response.Data.DataSet[i]['id']] = response.Data.DataSet[i];
			}
			_w.auction._buildGrid();
			_w.auction.rawData.Meta.itemName = 'stockPager';
			_w.auction.rawData.Meta.bind = _w.auction.pageAuctionGrid;
			_w.auction.ti.hydrateParam('gridPager', {
				constructor: 'GridPager',
				items: [_w.auction.rawData.Meta]
			});
			if (false === _w.auction.refresher)
			{
				_w.auction.refresher = setInterval(
					function ()
					{
						console.log('refreshing auction grid');
						_w.auction.loadAuctionGrid(null, {}, {});
					},
					120000
				);
			}
		},

		exportAuctionGrid: function ()
		{
			App.API.execTask(
				'gridAuction', {}, {'ExportToExcel': true},
				_w.auction._onExportReceived, _w.taskExecError,
				'EXPORT', true
			);
		},

		_onExportReceived: function (response)
		{
			var win = window.open();
			win.document.write(response);
		},

		clearAuctionGridContext: function ()
		{
			_w.auction.gridStatus = 'Inactive';
			try
			{
				$('select.gridAuctionFilter').each(function (i, elem) {
					$(elem).selectpicker('val', '');
					$(elem).selectpicker('refresh');
				});
			}
			catch (err)
			{
				console.log(err);
			}
			$('.gridAuctionContext').val('');
			$('.gridAuctionFilter').val('');
			_w.auction.basketOnly = false;
			$('#btnBasket').html('<i class="icon-shopping-cart icon-white"></i> My basket');
			_w.auction.searchAuctionGrid(true);
		},

		searchAuctionGrid: function (resetOrder)
		{
			_w.auction.gridStatus = 'Inactive';
			var filter = {
				count: 0,
				filters: {}
			};

			filter = _w.filterIfnotEmpty(filter, 'gridAuctionContext_DateFrom', 'auction.endDate', '>=');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionContext_DateTo', 'auction.endDate', '<=', ' 23:59:59');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionContext_RegNo', 'auction.registrationNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionContext_RefNo', 'auction.referenceNumber');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_basket', 'basket.archived', '!=');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Make', 'auction.makeId');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Seller', 'auction.auctionCompanyName');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Model', 'auction.modelName');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Type', 'auction.typeName');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Year', 'auction.yearName');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_KM', 'auction.stockKm');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Region', 'auction.regionId');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Bid', 'auction.currentBidPrice');
			filter = _w.filterIfnotEmpty(filter, 'gridAuctionFilter_Bids', 'numberOfBids');
			filter.filters['auction.jobState'] = 'Active';
			var request = {
				"Grid": {
					"Page": 1,
					"Filter": filter.filters
				}
			};

            console.log('resetOrder',resetOrder);

			//if (resetOrder)
			{
				request.Grid.OrderBy = {
					'auction.endDate': 'ASC',
					'auction.auctionCompanyName': 'ASC',
                    'auction.makeName': 'ASC',
                    'auction.modelName': 'ASC',
                    'auction.typeName': 'ASC',
                    'auction.yearName': 'ASC'
				};
			}

			_w.auction.loadAuctionGrid(null, request, {});
		},

		orderAuctionGrid: function (field, direction)
		{
            console.log('field',field);
            console.log('direction',direction);

			var order = {};
			order[field] = direction;
			_w.auction.loadAuctionGrid({}, {"Grid": {"Page": 1, "OrderBy": order}});
		}

	};

})();